#include "cache.h"

HDC Cache::hdc;
HBITMAP Cache::hbmp;
BYTE* Cache::lpPixels;
SIZE Cache::dibSize;
CRITICAL_SECTION Cache::cs;

void Cache::Init() {
	InitializeCriticalSection(&cs);
}

void Cache::Term() {
	if (hdc) DeleteDC(hdc);
	if (hbmp) DeleteObject(hbmp);
	hdc = NULL;
	hbmp = NULL;
	lpPixels = NULL;
	DeleteCriticalSection(&cs);
}

void Cache::CacheFillSolidRect(COLORREF rgb) {
	rgb = RGB(GetBValue(rgb), GetGValue(rgb), GetRValue(rgb));
	DWORD* p = (DWORD*)lpPixels;
	unsigned long* pend = (unsigned long*)p + (dibSize.cx * dibSize.cy);
	// lpPixels͕̒lɂȂ鎖̂unsignedŔr
	//while((ULONG_PTR)p < pend)
	while((unsigned long*)p < pend) {
		*p++ = rgb;
	}
}

HDC Cache::CreateDC()
{
	if (!hdc) { hdc = CreateCompatibleDC(NULL); }
	return hdc;
}

HBITMAP Cache::CreateDIB(int width, int height, BYTE** lplpPixels)
{
	if (dibSize.cx < width || dibSize.cy < height) {
		if (hbmp) {
			DeleteObject(hbmp);
		}

		if(dibSize.cx < width ) { dibSize.cx = width;  }
		if(dibSize.cy < height) { dibSize.cy = height; }

		BITMAPINFOHEADER bmiHeader;
		bmiHeader.biSize = sizeof(bmiHeader);
		bmiHeader.biWidth = dibSize.cx;
		bmiHeader.biHeight = -dibSize.cy;
		bmiHeader.biPlanes = 1;
		bmiHeader.biBitCount = 32;
		bmiHeader.biCompression = BI_RGB;
		bmiHeader.biSizeImage = 0;
		bmiHeader.biXPelsPerMeter = 0;
		bmiHeader.biYPelsPerMeter = 0;
		bmiHeader.biClrUsed = 0;
		bmiHeader.biClrImportant = 0;
		Cache::hbmp = CreateDIBSection(hdc, (CONST BITMAPINFO*)&bmiHeader, DIB_RGB_COLORS, (LPVOID*)&lpPixels, NULL, 0);
	}
	*lplpPixels = lpPixels;
	return hbmp;
}