#pragma once

template <int BUFSIZE = LF_FACESIZE, bool ignoreCase = false>
class StringHashT {
	DWORD	hash;
	WCHAR	name[BUFSIZE];

public:
	UINT	weight;

	StringHashT() {}
	StringHashT(LPCWSTR s)
	{
		Init(s);
	}
	void Init(LPCWSTR s)
	{
		wcsncpy(name, s, BUFSIZE);
		_UpdateHash();
	}
	bool operator ==(const StringHashT<BUFSIZE, ignoreCase>& x) const
	{
		if(ignoreCase)
			return !(hash != x.hash || wcscmp(name, x.name) != 0);
		else
			return !(hash != x.hash || wcscmp(name, x.name) != 0);
	}
	BOOL IsValidHash() const
	{
		return hash != 0;
	}
	DWORD Hash() const
	{
		return hash;
	}
	LPCWSTR c_str() const
	{
		return name;
 	}
	void _UpdateHash()
	{
		DWORD dw = 0;
		LPWSTR p;
		for (p = name; *p; p++) {
			dw <<= 3;
			if(ignoreCase)
				dw ^= *p;
			else
				dw ^= towlower(*p);
		}
		hash = dw;
	}
};

typedef StringHashT<>				StringHash;
typedef StringHashT<MAX_PATH,true>	StringHashMod;